/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef MBC_H
#define MBC_H

#include "types.h"

typedef long int time_t;

//extern int MBC1memorymodel;
extern unsigned int cart_address;
//extern int RAMenable;

extern int rumble_counter;
//extern int timeron;
//extern int LCDon;

/*extern int rom_bank;
extern int ram_bank;
extern int wram_bank;
extern int vram_bank;
extern int MBC1memorymodel;
extern int RAMenable;
extern unsigned short MBClo;
extern unsigned short MBChi;*/
extern int cameraIO;
//extern int RTCIO;
extern int RTC_latched;

extern int HuC3_register[8];
extern int HuC3_RAMvalue;
extern int HuC3_address;
extern int HuC3_RAMflag;

extern int MBC7_cs;
extern int MBC7_sk;
extern int MBC7_state;
extern int MBC7_buffer;
extern int MBC7_idle;
extern int MBC7_count;
extern int MBC7_code;
extern int MBC7_address;
extern int MBC7_writeEnable;
extern int MBC7_value;

struct rtc_clock
{
   int s; // seconds counter
   int m; // minutes counter
   int h; // hour counter
   int d; // day counter 
   int control; // carry bit, halt flag
   int cur_register;
   time_t last_time;
};

extern rtc_clock rtc,rtc_latch;

//extern int gdma_rest;

#define HUC3_READ 0
#define HUC3_WRITE 1
#define HUC3_NONE 2
extern int HuC3_flag;
extern unsigned int HuC3_time;
extern int HuC3_shift;
extern time_t HuC3_last_time;

extern int tama_flag;

extern int maxROMbank[9];
extern int maxRAMbank[6];

extern int RAM_always_enable;

extern int tama_flag;
extern byte tama_time;
extern int tama_val6;
extern int tama_val7;
extern int tama_val4;
extern int tama_val5;
extern int tama_count;
extern int tama_month;
extern int tama_change_clock;

extern int bc_select;

byte readmemory_default(register unsigned short address);

byte readmemory_MBC3(register unsigned short address);

byte readmemory_Camera(register unsigned short address);

void writememory_default(unsigned short address,register byte data);

void writememory_MBC1(unsigned short address,register byte data);

void writememory_MBC2(unsigned short address,register byte data);

void writememory_MBC3(unsigned short address,register byte data);

void writememory_MBC5(unsigned short address,register byte data);

void writememory_Camera(unsigned short address,register byte data);

byte readmemory_HuC3(register unsigned short address);

void writememory_HuC3(register unsigned short address,register byte data);

void writememory_MBC7(unsigned short address,register byte data);

byte readmemory_MBC7(register unsigned short address);

void writememory_TAMA5(register unsigned short address,register byte data);

byte readmemory_TAMA5(register unsigned short address);

void writememory_Rockman8(register unsigned short address,register byte data);

void writememory_BC(register unsigned short address,register byte data);

void writememory_8in1(register unsigned short address,register byte data);

void writememory_MMM01(register unsigned short address,register byte data);

void writememory_MK12(register unsigned short address,register byte data);

void writememory_poke(register unsigned short address,register byte data);

#endif


