/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <windows.h>
#include <stdio.h>
#include <dplay.h>

#include "dialogs.h"
#include "strings.h"
#include "main.h"
#include "rom.h"
#include "config.h"
#include "cheats.h"
#include "directinput.h"
#include "directplay.h"
#include "GB.h"

extern IDirectPlay4* DP;
int change_index = 0; // currently changing which button? 

char* stpncpy(char* to,char* from,int count)
{
   char *to_ptr = to;
   for(int i=0;i<count;++i,++to_ptr)
      *to_ptr = from[i];
   return to_ptr;
}

bool DoFileOpen(HWND hwnd,int gb_number)
{
   OPENFILENAME ofn;
   char szFileName[MAX_PATH];

   ZeroMemory(&ofn, sizeof(ofn));
   szFileName[0] = 0;

   ofn.lStructSize = sizeof(ofn);
   ofn.hwndOwner = hwnd;
   
   char ctrl_str[150];
   char* cptr = ctrl_str;

   cptr = stpncpy(cptr,str_table[GB_ROMS],strlen(str_table[GB_ROMS]));
   cptr = stpncpy(cptr," (*.gb,*.gbc,*.sgb,*.zip)\0*.gb;*.gbc;*.sgb;*.zip\0",strlen(" (*.gb,*.gbc,*.sgb,*.zip)*.gb;*.gbc;*.sgb;*.zip")+2);
   cptr = stpncpy(cptr,str_table[ALL_FILES],strlen(str_table[ALL_FILES]));
   cptr = stpncpy(cptr," (*.*)\0*.*\0\0",strlen(" (*.*)*.*")+3);
   
   ofn.lpstrFilter = ctrl_str;//"GB roms (*.gb,*.gbc,*.sgb,*.zip)\0*.gb;*.gbc;*.sgb;*.zip\0All files (*.*)\0*.*\0\0";
   ofn.lpstrFile = szFileName;
   ofn.nMaxFile = MAX_PATH;
   ofn.lpstrDefExt = "gb";

   ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
   SetCurrentDirectory(rom_directory);
   if(GetOpenFileName(&ofn))
   {
      GetCurrentDirectory(256,rom_directory);
      
      if(gb_number == 1)
         return GB1->load_rom(ofn.lpstrFile);  
      else
         return GB2->load_rom(ofn.lpstrFile);        
   }

   if(gb_number == 1)
      GB1->romloaded = false;  
   else
      GB2->romloaded = false;   

   return true;
}

BOOL CALLBACK FolderProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    switch (message) 
    { 
    case WM_INITDIALOG:
        SetDlgItemText(hwndDlg, ID_F_SAVE, save_directory);
        SetDlgItemText(hwndDlg, ID_F_STATE, state_directory);
    break;
    case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    GetDlgItemText(hwndDlg, ID_F_SAVE, save_directory,SAVE_PATH_SIZE); 
                    GetDlgItemText(hwndDlg, ID_F_STATE, state_directory,STATE_PATH_SIZE); 
 
                    // Fall through. 

                case IDCANCEL: 
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
            } 
    } 
    return FALSE; 
} 

int search_index = 0;
BOOL CALLBACK NetsessionProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{    
    switch (message) 
    { 
    case WM_INITDIALOG:
    break;
    case WM_TIMER:
    {
       bool result = Join_Session();
       if(++search_index > 20 || game_found || !result)
       {            
          DPSESSIONDESC2 dpsd;
          ZeroMemory(&dpsd, sizeof(dpsd));
          dpsd.dwSize          = sizeof(dpsd);
          dpsd.guidApplication = AppGUID;
          
          search_index = 0;
          KillTimer(hwndDlg, 1);
          DP->EnumSessions(&dpsd,0,DPConnect_EnumSessionsCallback,NULL,DPENUMSESSIONS_STOPASYNC);  
          SetDlgItemText(hwndDlg,ID_NET_JOINGAME,"Join");
          if(game_found)
             EndDialog(hwndDlg, wParam);
       }
    }
    break;
    case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case ID_NET_CREATEGAME:      
                    if(Create_Session())
                       EndDialog(hwndDlg, wParam);
                return TRUE;
                case ID_NET_JOINGAME:  
                    if(search_index == 0)
                    { 
                       bool result = Join_Session();
                       if(game_found)
                       {
                          DPSESSIONDESC2 dpsd;
                          ZeroMemory(&dpsd, sizeof(dpsd));
                          dpsd.dwSize          = sizeof(dpsd);
                          dpsd.guidApplication = AppGUID;
          
                          DP->EnumSessions(&dpsd,0,DPConnect_EnumSessionsCallback,NULL,DPENUMSESSIONS_STOPASYNC);  
                                         
                          EndDialog(hwndDlg, wParam);
                          return TRUE;
                       } else
                       if(result == true)
                       {
                          SetTimer( hwndDlg, 1, 250, NULL );  
                          SetDlgItemText(hwndDlg,ID_NET_JOINGAME,"Searching...");
                       }
                    } else
                    {
                       DPSESSIONDESC2 dpsd;
                       ZeroMemory(&dpsd, sizeof(dpsd));
                       dpsd.dwSize          = sizeof(dpsd);
                       dpsd.guidApplication = AppGUID;                    
                       
                       search_index = 0;
                       KillTimer(hwndDlg, 1);
                       DP->EnumSessions(&dpsd,0,DPConnect_EnumSessionsCallback,NULL,DPENUMSESSIONS_STOPASYNC);   
                       SetDlgItemText(hwndDlg,ID_NET_JOINGAME,"Join");
                    }
              
                return TRUE;

                case IDCANCEL: 
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
            } 
    } 
    return FALSE; 
} 

BOOL CALLBACK NetplayProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    HWND hwndlist = GetDlgItem(hwndDlg, ID_NET_SERVICE);
 
    switch (message) 
    { 
    case WM_INITDIALOG:
       SetDlgItemText(hwndDlg, ID_NET_PLAYERNAME, player_name);
        
       if(!Init_DP(hwndDlg))
       {
          debug_print("DirectPlay Init failed!");
          EndDialog(hwndDlg, wParam); 
       }
    break;
    case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                {
                    GetDlgItemText(hwndDlg, ID_NET_PLAYERNAME, player_name,100);
                    if(!strcmp(player_name,"\0"))
                    {
                       debug_print("Enter player name.");
                       return TRUE;
                    }
                    
                    int selected_conn = SendMessage(hwndlist, LB_GETCURSEL, 0, 0L);
                    if(selected_conn==-1)
                    {
                       debug_print("Select connection type.");
                       return TRUE;                          
                    }
                    if(!init_connection(selected_conn))
                    {
                       EndDialog(hwndDlg, wParam); 
                       return TRUE;
                    }

                    EndDialog(hwndDlg, wParam); 
                    DialogBox(hinst, MAKEINTRESOURCE(ID_NETSESSION_DIALOG), hwnd, (DLGPROC)NetsessionProc);
                }
                return TRUE;

                case IDCANCEL: 
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
            } 
    } 
    return FALSE; 
} 

gg_cheats old_cheats[MAXGGCHEATS];
int old_num;

// Cheat dialog box program
BOOL CALLBACK ChtProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    HWND hwndbox = GetDlgItem(hwndDlg, ID_CHT_CHEATS);

    switch (message) 
    { 
    case WM_INITDIALOG:
       for(int i=0;i<MAXGGCHEATS;++i)
          old_cheats[i] = cheat[i];
       old_num = number_of_cheats;
       for(int i=0;i<number_of_cheats;++i)
          SendMessage(hwndbox, LB_ADDSTRING, 0, (LPARAM)cheat[i].str );
    break;
    case WM_COMMAND: 
            switch (LOWORD(wParam)) 
            { 
                case ID_CHT_ADDBTN:
                   if(number_of_cheats < MAXGGCHEATS)
                   {
                      char cheat_str[20];
                      GetDlgItemText(hwndDlg, ID_CHT_ADD, cheat_str,20); 

                      if(add_cheat(cheat_str))
                         SendMessage(hwndbox, LB_ADDSTRING, 0, (LPARAM)cheat[number_of_cheats-1].str );
                      else
                         if(number_of_cheats != MAXGGCHEATS)
                            debug_print(str_table[GG_CHT_FORMAT]);
                   }   
                break;
                case ID_CHT_RMVBTN:
                {
                   int selected_cheat = SendMessage(hwndbox, LB_GETCURSEL, 0, 0L); 
                   if(selected_cheat != LB_ERR)
                   {
                      SendMessage(hwndbox,LB_DELETESTRING,(WPARAM)selected_cheat,0L);                      
                      remove_cheat(selected_cheat);
                   }
                }
                break;
                case IDOK: 
                   EndDialog(hwndDlg, wParam); 
                break;

 
                case IDCANCEL: 
                   number_of_cheats = old_num;
                   
                   for(int i=0;i<MAXGGCHEATS;++i)
                      cheat[i] = old_cheats[i];
                   EndDialog(hwndDlg, wParam); 
                return TRUE; 
            } 
    } 
    return FALSE; 
} 

// Change controls timer program
VOID CALLBACK TProc(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime)
{
   key_config = multi_key_config[current_controller];
   
   int changed = check_change_keys(change_index);

   key_config = multi_key_config[0];
   
   if(!changed)
      return;
      
   if(current_controller)
   {
      SetDlgItemText(hwnd, ID_CTRL_A+change_index, key_names[multi_key_config[current_controller][change_index]]); 
   }else
   {
      if(change_index < 13)            
         SetDlgItemText(hwnd, ID_CTRL_A+change_index, key_names[key_config[change_index]]); 
      else
         SetDlgItemText(hwnd, ID_SENSOR_LEFT+(change_index-13), key_names[key_config[change_index]]); 
   }
}  

// Change controls dialog box program   
BOOL CALLBACK CtrlProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{    
    switch(message) 
    { 
    case WM_INITDIALOG:
       for(int i=0;i<13;++i)
       {
          SetDlgItemText(hwndDlg, ID_CTRL_A+i, key_names[key_config[i]]);
          
          HWND hwndx = GetDlgItem(hwndDlg, ID_CTRL_A+i);
          SendMessage(hwndx, EM_SETREADONLY, TRUE,0L);
       }
       change_index = 0;
       
       timer_id = SetTimer(hwndDlg,20,100,TProc);
    break;
    case WM_COMMAND: 
            if(HIWORD(wParam) == EN_SETFOCUS && LOWORD(wParam) >= ID_CTRL_A && LOWORD(wParam) <= ID_CTRL_RIGHT)
            {
               change_index = LOWORD(wParam)-ID_CTRL_A;
               break;
            }
               
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    Kill_DI_change();     
                    KillTimer(hwndDlg,timer_id);           
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
                
                case IDCANCEL: 
                    Kill_DI_change();                
                    KillTimer(hwndDlg,timer_id);                    
                    DestroyWindow(hwndDlg); 
                    hwndCtrl = NULL; 
                return TRUE; 

            } 
    break;
    } 
    return FALSE; 
} 

// Change multi-controls dialog box program   
BOOL CALLBACK MultiCtrlProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{    
    switch(message) 
    { 
    case WM_INITDIALOG:
       for(int i=0;i<2;++i)
       {
          SetDlgItemText(hwndDlg, ID_CTRL_AUTO_A+i, key_names[multi_key_config[current_controller][i+6]]);
          
          HWND hwndx = GetDlgItem(hwndDlg, ID_CTRL_AUTO_A+i);
          SendMessage(hwndx, EM_SETREADONLY, TRUE,0L);
       }  
       for(int i=0;i<4;++i)
       {
          SetDlgItemText(hwndDlg, ID_CTRL_UP+i, key_names[multi_key_config[current_controller][i+9]]);
          
          HWND hwndx = GetDlgItem(hwndDlg, ID_CTRL_UP+i);
          SendMessage(hwndx, EM_SETREADONLY, TRUE,0L);
       }      
       for(int i=0;i<4;++i)
       {
          SetDlgItemText(hwndDlg, ID_CTRL_A+i, key_names[multi_key_config[current_controller][i]]);
          
          HWND hwndx = GetDlgItem(hwndDlg, ID_CTRL_A+i);
          SendMessage(hwndx, EM_SETREADONLY, TRUE,0L);
       }     
       change_index = 0;
       
       timer_id = SetTimer(hwndDlg,20,100,TProc);
    break;
    case WM_COMMAND: 
            if(HIWORD(wParam) == EN_SETFOCUS && LOWORD(wParam) >= ID_CTRL_A && LOWORD(wParam) <= ID_CTRL_RIGHT)
            {
               change_index = LOWORD(wParam)-ID_CTRL_A;
               break;
            }
               
            switch (LOWORD(wParam)) 
            { 
                case ID_CTRL_CLEAR:
                   for(int i=0; i<17;i++)
                      multi_key_config[current_controller][i] = 0;
                   for(int i=0;i<2;++i)
                   {
                      SetDlgItemText(hwndDlg, ID_CTRL_AUTO_A+i, key_names[multi_key_config[current_controller][i+6]]);
                   }  
                   for(int i=0;i<4;++i)
                   {
                      SetDlgItemText(hwndDlg, ID_CTRL_UP+i, key_names[multi_key_config[current_controller][i+9]]);
                      SetDlgItemText(hwndDlg, ID_CTRL_A+i, key_names[multi_key_config[current_controller][i]]);
                   }                           
                break;
                case IDOK: 
                    Kill_DI_change();     
                    KillTimer(hwndDlg,timer_id);           
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
                
                case IDCANCEL: 
                    Kill_DI_change();                
                    KillTimer(hwndDlg,timer_id);                    
                    DestroyWindow(hwndDlg); 
                    hwndCtrl = NULL; 
                return TRUE; 

            } 
    break;
    } 
    return FALSE; 
} 

// Change sensor controls dialog box program   
BOOL CALLBACK SensorProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{    
    switch(message) 
    { 
    case WM_INITDIALOG:
       for(int i=13;i<17;++i)
       {
          SetDlgItemText(hwndDlg, ID_SENSOR_LEFT+(i-13), key_names[key_config[i]]);
          
          HWND hwndx = GetDlgItem(hwndDlg, ID_SENSOR_LEFT+(i-13));
          SendMessage(hwndx, EM_SETREADONLY, TRUE,0L);
       }
       change_index = 0;
       
       timer_id = SetTimer(hwndDlg,20,100,TProc);
    break;
    case WM_COMMAND: 
            if(HIWORD(wParam) == EN_SETFOCUS && LOWORD(wParam) >= ID_SENSOR_LEFT && LOWORD(wParam) <= ID_SENSOR_DOWN)
            {
               change_index = LOWORD(wParam)-ID_SENSOR_LEFT+13;
               break;
            }
               
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    Kill_DI_change();     
                    KillTimer(hwndDlg,timer_id);                                 
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
                
                case IDCANCEL: 
                    Kill_DI_change();             
                    KillTimer(hwndDlg,timer_id);                         
                    DestroyWindow(hwndDlg); 
                    hwndCtrl = NULL; 
                return TRUE; 

            } 
    break;
    } 
    return FALSE; 
} 


VOID CALLBACK TJoyProc(HWND hwnd,UINT uMsg,UINT idEvent,DWORD dwTime)
{  
   int changed = check_change_joypad(change_index);
   
   if(!changed)
      return;

   char buffer[10];
   sprintf(buffer,"%d",joy_config[change_index]);
   SetDlgItemText(hwnd, ID_CTRLJOY_A+change_index, buffer); 
} 

// Change multi-controls dialog box program   
BOOL CALLBACK JoyCtrlProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{    
    switch(message) 
    { 
    case WM_INITDIALOG:
       for(int i=0;i<6;++i)
       {         
          HWND hwndx = GetDlgItem(hwndDlg, ID_CTRLJOY_A+i);
          SendMessage(hwndx, EM_SETREADONLY, TRUE,0L);
          char buffer[10];
          sprintf(buffer,"%d",joy_config[i]);
          SetDlgItemText(hwndDlg, ID_CTRLJOY_A+i, buffer); 
       }  
       change_index = 0;
       
       timer_id = SetTimer(hwndDlg,20,100,TJoyProc);
    break;
    case WM_COMMAND: 
            if(HIWORD(wParam) == EN_SETFOCUS && LOWORD(wParam) >= ID_CTRLJOY_A && LOWORD(wParam) <= ID_CTRLJOY_AUTO_B)
            {
               change_index = LOWORD(wParam)-ID_CTRLJOY_A;
               break;
            }
               
            switch (LOWORD(wParam)) 
            { 
                case IDOK: 
                    KillTimer(hwndDlg,timer_id);           
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
                
                case IDCANCEL:              
                    KillTimer(hwndDlg,timer_id);                    
                    EndDialog(hwndDlg, wParam); 
                return TRUE; 
            } 
    break;
    } 
    return FALSE; 
} 


