/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef GEST_DIRECTDRAW_H
#define GEST_DIRECTDRAW_H

#include "types.h"

#define WIN32_LEAN_AND_MEAN

#include <windows.h>

//31-63-31 565
#define RGB16(red,green,blue) ( (WORD)(((red)<<11)|((green)<<5)|(blue)) )
#define GBC_RGB(red,green,blue) ( (WORD)(((blue)<<10)|((green)<<5)|(red)) )

#define FILTER_NONE     0
#define FILTER_SOFT2X   1
#define FILTER_SCALE2X  2
#define FILTER_BLUR     3
#define FILTER_SCALE3X  4
extern int filter;
extern int filter_width;
extern int filter_height;
extern int border_filter;
extern int border_filter_width;
extern int border_filter_height;
extern HWND hwnd;

extern DWORD* gfx_pal32;
extern WORD* gfx_pal16;

void mix_gbc_colors();

extern int use_mmx;

extern void (*draw_border)();

bool change_filter();

extern RECT target_blt_rect;

extern char dx_message[60];
extern int message_time;

extern const unsigned short GBC_DMGBG_palettes[12][4];
extern const unsigned short GBC_DMGOBJ0_palettes[12][4];
extern const unsigned short GBC_DMGOBJ1_palettes[12][4];

extern const unsigned short LCD_palette_brown[4];
extern const unsigned short LCD_palette_green[4];
extern const unsigned short GB_palette_gray[4];

extern int lPitch;
extern int dx_bitcount;

#define SafeRelease(x) if(x) { x->Release(), x=NULL; }

void Kill_DD();

bool Init_DD();

extern void (*draw_screen)();
void draw_screen_mix16();
void draw_screen_mix32();
void draw_screen16();
void draw_screen32();

//void fill_line16(unsigned short* adr, unsigned long val, int count);

//void fill_line32(unsigned long* adr, unsigned long val, int count);

//void copy_line16(unsigned short* target, unsigned short* src, int count);

//void copy_line32(unsigned long* target, unsigned long* src, int count);

#ifdef ALLOW_DEBUG
void draw_debug_screen();
#endif

#endif
