/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*
    VisualBoyAdvance - a Gameboy and GameboyAdvance emulator
    Copyright (C) 1999-2004 by Forgotten

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MAINLOOP_H
#define MAINLOOP_H

extern int gbc_real_colors;
extern int color_option;
#define COL_BW       1
#define COL_LCDBROWN 2
#define COL_LCDGREEN 3
#define COL_GRAY     4

#define SGB_BORDER 1
#define SGB_INITB 2

#define B_UP 0
#define B_DOWN 1
#define B_LEFT 2
#define B_RIGHT 3
#define B_A 4
#define B_B 5
#define B_SELECT 6
#define B_START 7

extern int speedup;
#define SP_FS9    1
#define SP_SNDOFF 2
extern int speed_up_option;

extern int *key_config;
extern int multi_key_config[4][17];

#define KEY_A 0
#define KEY_B 1
#define KEY_START 2
#define KEY_SELECT 3
#define KEY_L 4
#define KEY_R 5
#define KEY_TURBO_A 6
#define KEY_TURBO_B 7
#define KEY_SPEEDUP 8
#define KEY_UP 9
#define KEY_DOWN 10
#define KEY_LEFT 11
#define KEY_RIGHT 12
#define KEY_SENSOR_L 13
#define KEY_SENSOR_R 14
#define KEY_SENSOR_U 15
#define KEY_SENSOR_D 16

#define SENSOR_LEFT 0
#define SENSOR_RIGHT 1
#define SENSOR_UP 2
#define SENSOR_DOWN 3

extern bool sprite_limit;
extern int LCDoff_option;
extern int sgb_border_option;
extern int unk_opcode_option;

extern int sensor_dir[4];
extern int sensorX;
extern int sensorY;

extern int frames;
extern int mix_frames;

int romsize(int number);

void reset(int gb_number);
void reset_no_change();

inline void check_sensor()
{
      if(sensor_dir[SENSOR_LEFT])
      {
         sensorX += 3;
         if(sensorX > 2197)
            sensorX = 2197;
         if(sensorX < 2047)
            sensorX = 2057;
      } else if(sensor_dir[SENSOR_RIGHT])
      {
         sensorX -= 3;
         if(sensorX < 1897)
            sensorX = 1897;
         if(sensorX > 2047)
            sensorX = 2037;
      } else if(sensorX > 2047) 
      {
         sensorX -= 2;
         if(sensorX < 2047)
            sensorX = 2047;
      } else 
      {
         sensorX += 2;
         if(sensorX > 2047)
            sensorX = 2047;
      }

      if(sensor_dir[SENSOR_UP])
      {
         sensorY += 3;
         if(sensorY > 2197)
            sensorY = 2197;
         if(sensorY < 2047)
            sensorY = 2057;
      } else if(sensor_dir[SENSOR_DOWN])
      {
         sensorY -= 3;
         if(sensorY < 1897)
            sensorY = 1897;
         if(sensorY > 2047)
            sensorY = 2037;
      } else if(sensorY > 2047) 
      {
         sensorY -= 2;
         if(sensorY < 2047)
            sensorY = 2047;
      } else 
      {
         sensorY += 2;
         if(sensorY > 2047)
            sensorY = 2047;
      }  
}

#endif
