/*
GEST - Gameboy emulator
Copyright (C) 2003-2004 TM

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef MEM_H
#define MEM_H

#include "types.h"
#include "GB.h"

#include "cheats.h"

extern byte *memory_another;

void copy_memory(unsigned short to,unsigned short from,int count);

bool write_save(int gb_number);
bool read_save(int gb_number);

inline byte readopcode(register unsigned short address) //for fast memory access
{
   if(number_of_cheats)
      for(int i=0;i<number_of_cheats;++i)
         if(address == cheat[i].address && (!(cheat[i].long_code) || (cheat[i].old_value == GB->mem_map[address>>12][address&0x0fff])))
            return cheat[i].new_value;

   return GB->mem_map[address>>12][address&0x0FFF];
}

extern byte (*readmemory)(unsigned short);

extern void (*writememory)(unsigned short address,byte data);

inline unsigned short readword(register unsigned short address) //for fast memory access
{
   return (unsigned short)(GB->mem_map[address>>12][address&0x0FFF]|(GB->mem_map[(address+1)>>12][(address+1)&0x0FFF]<<8));
}

inline void writeword(register unsigned short address, register unsigned short data) //for fast memory access
{
   GB->mem_map[address>>12][address&0x0FFF] = data;
   GB->mem_map[((address+1)&0xFFFF)>>12][(address+1)&0x0FFF] = (data>>8);
}

void mem_reset(int gb_number);

#endif 
